/*
 * Copyright (c) 2005 Jared Momose.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote products
 *    derived from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#define _ASSEMBLY
#include <or1200.h>


ENTRY(memcpy):
	l.sfltui r5,4
	l.bf	L1bloop
	l.addi	r11,r3,0
Lhead:
	l.andi	r6,r3,3
	l.sfeq	r6,r0
	l.bf	L4b
	l.nop	0		/* delay slot */
	l.lbz	r6,0(r4)
	l.sb	0(r3),r6
	l.addi	r3,r3,1
	l.addi	r4,r4,1
	l.j	Lhead
	l.addi	r5,r5,-1	/* delay slot */
L4b:
	l.andi	r6,r4,3
	l.sfne	r6,r0
	l.bf	L2b
	l.nop	0		/* delay slot */
L4bloop:
	l.sfltui r5,4
	l.bf	L2bloop
	l.nop	0		/* delay slot */
	l.lwz	r6,0(r4)
	l.sw	0(r3),r6
	l.addi	r3,r3,4
	l.addi	r4,r4,4
	l.j	L4bloop
	l.addi	r5,r5,-4	/* delay slot */
L2b:
	l.andi	r6,r4,1
	l.sfne	r6,r0
	l.bf	L1bloop
	l.nop	0		/* delay slot */
L2bloop:
	l.sfltui r5,2
	l.bf	L1bloop
	l.nop	0		/* delay slot */
	l.lhz	r6,0(r4)
	l.sh	0(r3),r6
	l.addi	r3,r3,2
	l.addi	r4,r4,2
	l.j	L2bloop
	l.addi	r5,r5,-2	/* delay slot */
L1bloop:
	l.sfeq	r5,r0
	l.bf	Lend
	l.nop	0		/* delay slot */
	l.lbz	r6,0(r4)
	l.sb	0(r3),r6
	l.addi	r3,r3,1
	l.addi	r4,r4,1
	l.j	L1bloop
	l.addi	r5,r5,-1	/* delay slot */
Lend:
	l.jr	r9
	l.nop	0

