#include "board.h"
#include "uart.h"
#define print_port 0x7ff0
#define print_char_port 0x7ff1
#define print_int_port 0x7ff2
#define print_long_port 0x7ff4


	
void print(unsigned char* ptr)//Verilog Test Bench Use 
{
	#ifdef DOS
			printf("%s ",ptr); 
	#else
		
	while (*ptr) {
	
		*(volatile unsigned char*)print_port=*(ptr++);
	}

	*(volatile unsigned char*)print_port=0x00;//Write Done
	#endif
}

void print_char(unsigned char val)//Little Endian write out 16bit number 
{
	#ifdef DOS
		printf("%x ",val);
	#else
	*(volatile unsigned char*)print_char_port=(unsigned char)val ;
	#endif

}
void print_short(short val)//Little Endian write out 16bit number 
{	
	#ifdef DOS
		printf("%x",val);
	#else
		*(volatile unsigned short*)print_int_port=val ;
	#endif
	

}

void print_long(unsigned long val)//Little Endian write out 32bit number 
{
	#ifdef DOS
			printf("%x",val);
	#else
			*(volatile unsigned long*)print_long_port=val;

	#endif

}

#define BOTH_EMPTY (UART_LSR_TEMT | UART_LSR_THRE)

#define WAIT_FOR_XMITR \
        do { \
                lsr = REG8(UART_BASE + UART_LSR); \
        } while ((lsr & BOTH_EMPTY) != BOTH_EMPTY)

#define WAIT_FOR_THRE \
        do { \
                lsr = REG8(UART_BASE + UART_LSR); \
        } while ((lsr & UART_LSR_THRE) != UART_LSR_THRE)

#define CHECK_FOR_CHAR (REG8(UART_BASE + UART_LSR) & UART_LSR_DR)

#define WAIT_FOR_CHAR \
         do { \
                lsr = REG8(UART_BASE + UART_LSR); \
         } while ((lsr & UART_LSR_DR) != UART_LSR_DR)

void uart_init(void)
{
  int divisor;

  /* Reset receiver and transmiter */
  REG8(UART_BASE + UART_FCR) = UART_FCR_ENABLE_FIFO | UART_FCR_CLEAR_RCVR | UART_FCR_CLEAR_XMIT | UART_FCR_TRIGGER_14;

  /* Disable all interrupts */
  REG8(UART_BASE + UART_IER) = 0x00;

  /* Set 8 bit char, 1 stop bit, no parity */
  REG8(UART_BASE + UART_LCR) = UART_LCR_WLEN8 & ~(UART_LCR_STOP | UART_LCR_PARITY);

  /* Set baud rate */
  divisor = IN_CLK/(16 * UART_BAUD_RATE);
  REG8(UART_BASE + UART_LCR) |= UART_LCR_DLAB;
  REG8(UART_BASE + UART_DLL) = divisor & 0x000000ff;
  REG8(UART_BASE + UART_DLM) = (divisor >> 8) & 0x000000ff;
  REG8(UART_BASE + UART_LCR) &= ~(UART_LCR_DLAB);
}

void uart_putc(char c)
{
  unsigned char lsr;
        
  WAIT_FOR_THRE;
  REG8(UART_BASE + UART_TX) = c;
  if(c == '\n') {
    WAIT_FOR_THRE;
    REG8(UART_BASE + UART_TX) = '\r';
  }
  WAIT_FOR_XMITR;
}

char uart_getc(void)
{
  unsigned char lsr;
  char c;

  WAIT_FOR_CHAR;
  c = REG8(UART_BASE + UART_RX);
  return c;
}

char *str = "Hello OR1200 world!!!\n";
int main (void)
{
  char *s;
  int i;
   for (i=0;i<10;i++) { 
   	print("Debug Port Test\n");
   }
  uart_init ();
  
  for (s = str; *s; s++)
    uart_putc (*s);
   
  print("$finish");
 // while (1)
 //   uart_putc (uart_getc () + 1);

  return 0;
}

